#include <windows.h>
#include <stdio.h>
#define _WIN32_WINNT 0x0500  // !!!!!!
#include <winioctl.h>


#define GETVERSIONOUTPARAMS     GETVERSIONINPARAMS
#define DFP_GET_VERSION         SMART_GET_VERSION
#define DFP_RCV_DRIVE_DATA      SMART_RCV_DRIVE_DATA

const WORD IDE_ATAPI_IDENTIFY = 0xA1;   // ATAPI
const WORD IDE_ATA_IDENTIFY   = 0xEC;   // ATA
const int MAX_IDE_DRIVES = 4;

static BOOL DoIdentify(HANDLE hPhysicalDriveIOCTL, PSENDCMDINPARAMS pSCIP,
								PSENDCMDOUTPARAMS pSCOP, BYTE btIDCmd, BYTE btDriveNum,
								PDWORD pdwBytesReturned)
{
    // Set up data structures for IDENTIFY command.
    pSCIP->cBufferSize = IDENTIFY_BUFFER_SIZE;
    pSCIP->irDriveRegs.bFeaturesReg = 0;
    pSCIP->irDriveRegs.bSectorCountReg  = 1;
    pSCIP->irDriveRegs.bSectorNumberReg = 1;
    pSCIP->irDriveRegs.bCylLowReg  = 0;
    pSCIP->irDriveRegs.bCylHighReg = 0;
	
    // Compute the drive number.
    pSCIP->irDriveRegs.bDriveHeadReg = (btDriveNum & 1) ? 0xB0 : 0xA0;
	
    // The command can either be IDE identify or ATAPI identify.
    pSCIP->irDriveRegs.bCommandReg = btIDCmd;
    pSCIP->bDriveNumber = btDriveNum;
    pSCIP->cBufferSize = IDENTIFY_BUFFER_SIZE;
	
    return DeviceIoControl(hPhysicalDriveIOCTL, DFP_RCV_DRIVE_DATA,
		(LPVOID)pSCIP,
		sizeof(SENDCMDINPARAMS) - 1,
		(LPVOID)pSCOP,
		sizeof(SENDCMDOUTPARAMS) + IDENTIFY_BUFFER_SIZE - 1,
		pdwBytesReturned, NULL);
}
//---------------------------------------------------------------------------
// for Winndows NT4/2000/XP 
//---------------------------------------------------------------------------
VOID  ReadPhysicalDriveOnNT( BYTE * szSerialNumber)
{
    BYTE btIDOutCmd[sizeof(SENDCMDOUTPARAMS) + IDENTIFY_BUFFER_SIZE - 1];
	
    for(int nDrive=0; nDrive < MAX_IDE_DRIVES; nDrive++)
    {
        HANDLE hPhysicalDriveIOCTL;
        char szDriveName[32];
		
        sprintf(szDriveName, "\\\\.\\PhysicalDrive%d", nDrive);
        hPhysicalDriveIOCTL = CreateFile(szDriveName,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
			OPEN_EXISTING, 0, NULL);
		
        if(hPhysicalDriveIOCTL != INVALID_HANDLE_VALUE)
        {
            DWORD dwBytesReturned = 0;
            GETVERSIONOUTPARAMS gvopVersionParams;
			
            // Get the version, etc of PhysicalDrive IOCTL
            ZeroMemory(&gvopVersionParams, sizeof(GETVERSIONOUTPARAMS));
			
            if(!DeviceIoControl(hPhysicalDriveIOCTL, DFP_GET_VERSION,
				NULL, 0, &gvopVersionParams, sizeof(gvopVersionParams),
				&dwBytesReturned, NULL))
            {
                continue;
            }
			
            if(gvopVersionParams.bIDEDeviceMap > 0)
            {
                // IDE or ATAPI IDENTIFY cmd
                BYTE btIDCmd = 0;
                SENDCMDINPARAMS InParams;
                // Now, get the ID sector for all IDE devices in the system.
                // If the device is ATAPI use the IDE_ATAPI_IDENTIFY command,
                // otherwise use the IDE_ATA_IDENTIFY command
                btIDCmd =(BYTE)( (gvopVersionParams.bIDEDeviceMap >> nDrive & 0x10) ?IDE_ATAPI_IDENTIFY : IDE_ATA_IDENTIFY );
                ZeroMemory(&InParams, sizeof(SENDCMDINPARAMS));
                ZeroMemory(btIDOutCmd, sizeof(btIDOutCmd));
				
                if(DoIdentify(hPhysicalDriveIOCTL,
					&InParams, (PSENDCMDOUTPARAMS)btIDOutCmd,
					(BYTE)btIDCmd, (BYTE)nDrive, &dwBytesReturned))
                {
					int i ;
#ifdef ASCII_SHOW
                    DWORD dwDiskData[256];
#endif 
                    USHORT *pIDSector;
					
                    pIDSector = (USHORT*)((SENDCMDOUTPARAMS*)btIDOutCmd)->bBuffer;
#ifdef ASCII_SHOW
                    for(i=0; i < 256; i++)
                        dwDiskData[i] = pIDSector[i];
#endif

					for (i=0;i<20;i++)
						szSerialNumber[i] = ((BYTE *)&pIDSector[10])[i];

#ifdef ASCII_SHOW
					sprintf((char * )szSerialNumber,"%04X%04X%04X%04X%04X%04X%04X%04X%04X%04X",
						dwDiskData[10],dwDiskData[11],dwDiskData[12],dwDiskData[13],dwDiskData[14],
						dwDiskData[15],dwDiskData[16],dwDiskData[17],dwDiskData[18],dwDiskData[19]);
#endif
					break;
                }
            }
            CloseHandle (hPhysicalDriveIOCTL);
        }
    }
}
